/* This file is part of guile-sql.
   Copyright (C) 2002 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <libguile.h>

#define MAX_IFACES 32

struct sql_connect {
	int iface;
	char *hostname;
	struct in_addr hostaddr;
	int port;
	char *username;
	char *database;
	void *data;
};

struct sql_result {
	SCM owner;
	void *data;
};

struct sql_iface {
	char *name;
	SCM (*mark) (struct sql_connect *);
	scm_sizet (*free) (struct sql_connect *);
	SCM (*connect) (char *hostname, int port,
			char *dbname, char *user, char *pass, const char *why);
	void (*close) (struct sql_connect *);
	SCM (*query) (struct sql_connect *, char *query);
};

extern struct sql_iface sql_iftab[];

SCM sql_connect_create (char *name);
SCM scm_makenum (unsigned long val);
	
